# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

Name:           maven-plugin-tools3
Version:        3.2
Release:        2%{?dist}
Epoch:          0
Summary:        Maven Plugin Tools
License:        ASL 2.0
Group:          Development/Java
URL:            http://maven.apache.org/plugin-tools/
Source0:        maven-plugin-tools-3.2.tar.gz
# svn export https://svn.apache.org/repos/asf/maven/plugin-tools/tags/maven-plugin-tools-3.2
# tar czf maven-plugin-tools-3.2.tar.gz maven-plugin-tools-3.2
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-plugin-plugin-META-INF-bootstrap.tgz
Patch0:         %{name}-pom.patch
Patch1:         %{name}-script-ant-pom.patch
Patch2:         %{name}-maven-script-ant-AntMojoWrapper.patch
Patch3:         %{name}-maven-script-ant-AntMojoWrapperTest.patch
Patch4:         %{name}-generators-PluginHelpGenerator.patch
Patch5:         %{name}-generators-GeneratorUtils.patch
Patch6:         %{name}-java-pom.patch
Patch7:         %{name}-annotations-pom.patch
Patch8:         %{name}-annotations-JavaAnnotationsMojoDescriptorExtractor.patch
Patch9:         %{name}-plugin-plugin-pom.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildArch:      noarch

BuildRequires:    jpackage-utils >= 0:1.7.5
BuildRequires:    java-devel >= 0:1.6.0
BuildRequires:    ant >= 0:1.7
BuildRequires:    junit
BuildRequires:    maven3
BuildRequires:    maven-surefire-maven-plugin 
BuildRequires:    maven-surefire-provider-junit3
BuildRequires:    modello
BuildRequires:    bsh
BuildRequires:    fest
BuildRequires:    fest-assert
BuildRequires:    plexus-container-default
BuildRequires:    plexus-utils
BuildRequires:    jtidy
BuildRequires:    qdox >= 0:1.6.3
BuildRequires:    apache-commons-parent

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Provides:       maven2-plugin-plugin = %{epoch}:%{version}-%{release}
Obsoletes:      maven2-plugin-plugin < %{epoch}:%{version}-%{release}
Requires:    java >= 0:1.6.0
Requires:    bsh
Requires:    jtidy
Requires:    maven2 >= 0:2.0.8
Requires:    maven-doxia
Requires:    maven-doxia-sitetools
Requires:    maven-shared-reporting-impl
Requires:    plexus-container-default
Requires:    plexus-utils
Requires:    qdox >= 0:1.6.3

%description
The Maven Plugin Tools contains the necessary tools to be 
able to produce Maven Plugins in a variety of languages.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n maven-plugin-tools-%{version}
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2
%patch3 -p0 -b .sav3
%patch4 -p0 -b .sav4
%patch5 -p0 -b .sav5
%patch6 -p0 -b .sav6
%patch7 -p0 -b .sav7
%patch8 -p0 -b .sav8
%patch9 -p0 -b .sav9
pushd maven-plugin-plugin/src/main/resources
tar xzf %{SOURCE3}
popd

%build
cp %{SOURCE1} settings.xml
sed -i -e "s|<url>__INTERNAL_REPO_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
sed -i -e "s|<url>__EXTERNAL_REPO_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml

export MAVEN_SETTINGS=$(pwd)/settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL

mvn-rpmbuild \
    -e \
    -s $MAVEN_SETTINGS \
    -Dmaven.test.failure.ignore=true \
    -Dmaven.local.depmap.file=%{SOURCE2} \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    install  javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 maven-plugin-annotations/target/maven-plugin-annotations-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-annotations-%{version}.jar
install -m 644 maven-plugin-plugin/target/maven-plugin-plugin-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-plugin-%{version}.jar
install -m 644 maven-plugin-tools-annotations/target/maven-plugin-tools-annotations-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/annotations-%{version}.jar
install -m 644 maven-plugin-tools-ant/target/maven-plugin-tools-ant-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/ant-%{version}.jar
install -m 644 maven-plugin-tools-api/target/maven-plugin-tools-api-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/api-%{version}.jar
install -m 644 maven-plugin-tools-beanshell/target/maven-plugin-tools-beanshell-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/beanshell-%{version}.jar
install -m 644 maven-plugin-tools-generators/target/maven-plugin-tools-generators-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/generators-%{version}.jar
install -m 644 maven-plugin-tools-javadoc/target/maven-plugin-tools-javadoc-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/javadoc-%{version}.jar
install -m 644 maven-plugin-tools-java/target/maven-plugin-tools-java-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/java-%{version}.jar
install -m 644 maven-plugin-tools-model/target/maven-plugin-tools-model-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/model-%{version}.jar
install -m 644 maven-script/maven-script-ant/target/maven-script-ant-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/script-ant-%{version}.jar
install -m 644 maven-script/maven-script-beanshell/target/maven-script-beanshell-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/script-beanshell-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; \
  do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -pm 644 pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}.pom
%add_to_maven_depmap org.apache.maven.plugin-tools maven-plugin-tools %{version} JPP/%{name} %{name}
%add_to_maven_depmap org.apache.maven maven-plugin-tools %{version} JPP/%{name} %{name}
 
install -pm 644 maven-plugin-annotations/pom.xml.sav* \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-plugin-annotations.pom
%add_to_maven_depmap org.apache.maven.plugin-tools maven-plugin-annotations %{version} JPP/%{name} plugin-annotations
%add_to_maven_depmap org.apache.maven maven-plugin-annotations %{version} JPP/%{name} plugin-annotations

install -pm 644 maven-plugin-plugin/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-plugin-plugin.pom
%add_to_maven_depmap org.apache.maven.plugins maven-plugin-plugin %{version} JPP/%{name} plugin-plugin
%add_to_maven_depmap org.apache.maven.plugins maven-plugin-plugin %{version} JPP/%{name} plugin-plugin

install -pm 644 maven-plugin-tools-annotations/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-annotations.pom
%add_to_maven_depmap org.apache.maven.plugin-tools maven-plugin-tools-annotations %{version} JPP/%{name} annotations
%add_to_maven_depmap org.apache.maven maven-plugin-tools-annotations %{version} JPP/%{name} annotations

install -pm 644 maven-plugin-tools-ant/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-ant.pom
%add_to_maven_depmap org.apache.maven.plugin-tools maven-plugin-tools-ant %{version} JPP/%{name} ant
%add_to_maven_depmap org.apache.maven maven-plugin-tools-ant %{version} JPP/%{name} ant

install -pm 644 maven-plugin-tools-api/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-api.pom
%add_to_maven_depmap org.apache.maven.plugin-tools maven-plugin-tools-api %{version} JPP/%{name} api
%add_to_maven_depmap org.apache.maven maven-plugin-tools-api %{version} JPP/%{name} api

install -pm 644 maven-plugin-tools-beanshell/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-beanshell.pom
%add_to_maven_depmap org.apache.maven.plugin-tools maven-plugin-tools-beanshell %{version} JPP/%{name} beanshell
%add_to_maven_depmap org.apache.maven maven-plugin-tools-beanshell %{version} JPP/%{name} beanshell

install -pm 644 maven-plugin-tools-generators/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-generators.pom
%add_to_maven_depmap org.apache.maven.plugin-tools maven-plugin-tools-generators %{version} JPP/%{name} generators
%add_to_maven_depmap org.apache.maven maven-plugin-tools-generators %{version} JPP/%{name} generators

install -pm 644 maven-plugin-tools-javadoc/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-javadoc.pom
%add_to_maven_depmap org.apache.maven.plugin-tools maven-plugin-tools-javadoc %{version} JPP/%{name} javadoc
%add_to_maven_depmap org.apache.maven maven-plugin-tools-javadoc %{version} JPP/%{name} javadoc

install -pm 644 maven-plugin-tools-java/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-java.pom
%add_to_maven_depmap org.apache.maven.plugin-tools maven-plugin-tools-java %{version} JPP/%{name} java
%add_to_maven_depmap org.apache.maven maven-plugin-tools-java %{version} JPP/%{name} java

install -pm 644 maven-plugin-tools-model/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-model.pom
%add_to_maven_depmap org.apache.maven.plugin-tools maven-plugin-tools-model %{version} JPP/%{name} model
%add_to_maven_depmap org.apache.maven maven-plugin-tools-model %{version} JPP/%{name} model

install -pm 644 maven-script/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-script.pom
%add_to_maven_depmap org.apache.maven.plugin-tools maven-plugin-tools-script %{version} JPP/%{name} script
%add_to_maven_depmap org.apache.maven maven-plugin-tools-script %{version} JPP/%{name} script

install -pm 644 maven-script/maven-script-ant/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-script-ant.pom
%add_to_maven_depmap org.apache.maven.plugin-tools maven-plugin-tools-script-ant %{version} JPP/%{name} script-ant
%add_to_maven_depmap org.apache.maven maven-plugin-tools-script-ant %{version} JPP/%{name} script-ant

install -pm 644 maven-script/maven-script-beanshell/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-script-beanshell.pom
%add_to_maven_depmap org.apache.maven.plugin-tools maven-plugin-tools-script-beanshell %{version} JPP/%{name} script-beanshell
%add_to_maven_depmap org.apache.maven maven-plugin-tools-script-beanshell %{version} JPP/%{name} script-beanshell

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/

ln -s %{name}-%{version} \
     $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root,-)
%{_javadir}/%{name}
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/*

%changelog
* Tue Jul 30 2013 Ralph Apel <r.apel@r-apel.de> 0:3.2-2
- Fix depmaps

* Sun Jul 28 2013 Ralph Apel <r.apel@r-apel.de> 0:3.2-1
- 3.2 as maven-plugin-tools3 : maven-plugin-tools-2.4.3 
  can't be replaced

* Mon Jun 06 2011 David Walluck <dwalluck@redhat.com> 0:2.4.3-5
- BuildRequires: l10n-maven-plugin

* Mon Jan 10 2011 David Walluck <dwalluck@redhat.com> 0:2.4.3-4
- Requires: qdox >= 0:1.6.3 for maven-plugin-tools-java
- fix BuildRoot
- fix License

* Sun Dec 05 2010 Ralph Apel <r.apel@r-apel.de> - 0:2.4.3-3
- Do we need qdox?

* Sat Dec 04 2010 Ralph Apel <r.apel@r-apel.de> - 0:2.4.3-2
- Add alternative depmaps
- Fix for modello-1.3

* Sat Oct 02 2010 Ralph Apel <r.apel@r-apel.de> - 0:2.4.3-1
- 2.4.3 adding maven-plugin-tools-javadoc

* Wed May 20 2009 Fernando Nasser <fnasser@redhat.com> - 0:2.1-3
- Fix license
- Fix URL

* Mon Apr 27 2009 Yong Yang <yyang@redhat.com> - 0:2.1-2
- Add BRs for maven-doxia*
- Rebuild with maven2-2.0.8 built in non-bootstrap mode

* Mon Mar 09 2009 Yong Yang <yyang@redhat.com> - 0:2.1-1
- Import from dbhole's maven2 2.0.8 packages

* Mon Apr 07 2008 Deepak Bhole <dbhole@redhat.com> - 0:2.1-0jpp.1
- Initial build
